import java.io.*;
import java.lang.*;

public class BenderProtocol {

    private String tmpversion = "none";
    private String tmpnick 	= "none";
    private String tmpside 	= "none";
    private String tmpcolour = "none";

    private	String[] possibletags = { "version", "nick:" , "side:" , "colour:" ,"terminates", "status", "say:", "update", "ready", "options", "cmd:", "time" };

    public String processInput (String recvline, UserData udatax, String cliid, Values valxx, ActionEventQueue AEQ) {
        boolean knowntag = false;

        // we check for any protocol keywords
        for (int i=0; i <= 11; i++) {
            if (recvline.indexOf(possibletags[i]) >= 0) { knowntag = true; }
        }

        if (!knowntag) { recvline = "PROTOCOL ERROR - UNKNOWN COMMAND"; }
        else {
            udatax.saveTimeStamp(udatax, valxx, cliid);
            recvline = this.createresult(recvline, udatax, cliid, valxx, AEQ);
        }
        return recvline;
    }




    public String createresult(String rvline, UserData udatay, String cliid, Values valxy, ActionEventQueue AEQ) {

        String status, chat, rvtmp, options, command;

        // check for version
        if ((rvline.indexOf(possibletags[0])) >= 0 ) {
            if (rvline.length() < 11) { rvline = "PROTOCOL ERROR"; }
            else {
                tmpversion = rvline.substring(8,rvline.length());
                rvtmp = udatay.setUserInfo (udatay, cliid, tmpversion, tmpnick, tmpside, tmpcolour, valxy);
                if (rvtmp.equals("")) { rvline = "";}
                else { rvline = rvtmp; }
            }
        }

        // check for nick
        if ((rvline.indexOf(possibletags[1])) >= 0 ) {
            tmpnick = rvline.substring(6,rvline.length()); // it used to be 5, but client seems to have a problem with it.
            if (!udatay.checkNick(cliid, tmpnick))
            { tmpnick = "none"; rvline = "PROTOCOL ERROR. RECHOOSE NICK. NICK GONE ALREADY"; }
            else
            {
                rvtmp = udatay.setUserInfo (udatay, cliid, tmpversion, tmpnick, tmpside, tmpcolour, valxy);
                if (rvtmp.equals("")) { rvline = ""; }
                else { rvline = rvtmp; }
            }
        }

        // check for side
        if ((rvline.indexOf(possibletags[2])) >= 0 ) {
            tmpside = rvline.substring(6,rvline.length()); // value used to be 5, but the client seems to have a problem with it.
            //System.out.println ("DEBUG ### " + tmpside);
            if ( (tmpside.equals("gdi")) || (tmpside.equals("nod")) ) {
                rvtmp = udatay.setUserInfo (udatay, cliid, tmpversion, tmpnick, tmpside, tmpcolour, valxy);
                if (rvtmp.equals("")) { rvline = ""; }
                else { rvline = rvtmp; }
            }
            else {
                rvline = "PROTOCOL ERROR. CHOOSE ANOTHER SIDE.";
            }
        }

        // check for colour
        if ((rvline.indexOf(possibletags[3])) >= 0 ) {
            tmpcolour = rvline.substring(8,rvline.length()); //used to be 7, but client seems to have a problem with it.
            //System.out.println ("DEBUG AT COLOURCHECK : " + tmpcolour);
            if (!udatay.checkColour(cliid, tmpcolour)) // checkColour() returns false if colourcheck has failed.
            { tmpcolour = "none"; rvline = "PROTOCOL ERROR. INVALID COLOUR. VALID COLOURS ARE : red, orange, yellow, green, blue and turquoise"; }
            else
            {
                rvtmp = udatay.setUserInfo (udatay, cliid, tmpversion, tmpnick, tmpside, tmpcolour, valxy);
                if (rvtmp.equals("")) { rvline = "LOGIN OK"; }
                else { rvline = rvtmp; }
            }
            udatay.printUserInfo(cliid, valxy);
        }

        // terminates
        if ((rvline.indexOf(possibletags[4])) >= 0 ) {
            rvline = "GOOD BYE CLIENT";
        }

        // status
        if ((rvline.indexOf(possibletags[5])) >= 0 ) {
            if (rvline.length() < 6) { rvline = "PROTOCOL ERROR"; }
            else {
                status = rvline.substring(7,rvline.length());
                rvline = "STATUS OF " + udatay.printUserInfoToClient(status, valxy);
            }
        }

        // say
        if ((rvline.indexOf(possibletags[6])) >= 0 ) {
            chat = rvline.substring(4,rvline.length());
            rvline = "CHAT FROM " + cliid + " ::: " + chat;
            udatay.putintoChatBuffer(rvline);
        }

        // update
        if ((rvline.indexOf(possibletags[7])) >= 0 ) {
            status = rvline.substring(0,rvline.length());
            rvline = udatay.printServerInfo(cliid, valxy);
        }

        // ready
        if ((rvline.indexOf(possibletags[8])) >= 0 ) {
            status = rvline.substring(0,rvline.length());
            rvline = udatay.setClientAsReady(cliid, valxy);
        }

        // options
        if ((rvline.indexOf(possibletags[9])) >= 0 ) {
            options = rvline.substring(0,rvline.length());
            //rvline = udatay.printOptions(valxy);
            rvline = valxy.toString();
        }

        // cmd
        if ((rvline.indexOf(possibletags[10])) >= 0 ) {
            command = rvline.substring(4,rvline.length());
            AEQ.addEvent(command, cliid);
            rvline = "";
        }

        if ((rvline.indexOf(possibletags[11])) >= 0) {
            udatay.saveTimeStamp(udatay, valxy, cliid);
            rvline = "";
        }

        return rvline;

    }

}
