import java.net.*;
import java.io.*;

public class UserData {

    private static String player[];
    private static String version[];
    private static String nick[];
    private static String side[];
    private static String colour[];
    private static long time[];
    private static boolean connection[];
    private static boolean ready[];
    private static boolean pingtimeout[];
    private static String ChatBuffer;
    private static Socket socketcontainer[];
    private static Socket metaserversocket;
    private static PrintWriter metaserversocketout;
    private static BufferedReader metaserversocketin;

    public void Init() {
        player 		= new String[8];
        version 		= new String[8];
        nick 	        	= new String[8];
        side 			= new String[8];
        colour 		= new String[8];
        time            	= new long[8];
        connection 	= new boolean[8];
        ready 		= new boolean[8];
        pingtimeout     	= new boolean[8];
	socketcontainer = new Socket[8];

	for (int position=1; position<=7; position++) {
		player[position] = "player" + position;
		connection[position] = false;
		ready[position] = false;
		pingtimeout[position] = false;
		version[position] = "none";
		nick[position] = "none";
		side[position] = "none";
		colour[position] = "none";
	}
    }

    public void registerMetaServer(Socket msock, UserData udata, BufferedReader mssin, PrintWriter mssout) {
    	metaserversocket = msock;
	metaserversocketout = mssout;
	metaserversocketin = mssin;
    }

    public Socket getMetaServerSocket() {
    	return metaserversocket;
    }
    
    public PrintWriter getMetaServerOut() {
    	return metaserversocketout;
    }
    
    public BufferedReader getMetaServerIn() {
    	return metaserversocketin;
    }

    public void registerSocket(String cliid, Socket clisock, UserData udata, Values val) {
    	for (int position = 1; position <= val.getmaxplayers(); position++) {
		if (player[position].equals(cliid)) {
			//System.out.println ("##debug : socket for " + cliid + " registered.");
			socketcontainer[position] = clisock;
		}
	}
    }

    public void closeSocket(String cliid, UserData udata, Values val) {
	for (int position = 1; position <= val.getmaxplayers(); position++) {
		if (player[position].equals(cliid)) {
			System.out.println (cliid + " :: Closed connection to " + socketcontainer[position].getInetAddress() + " due ping timeout error.");
			val.playernumber((val.getplayernumber())-1);
        		System.out.println ("set number of all players set to : " + val.getplayernumber() + ".");
        		udata.cleanupUser(cliid, val);
			try {
				socketcontainer[position].close();
			} catch (IOException e) {}
		}
	}
    }

    public void saveTimeStamp(UserData udate, Values val ,String uplayer) {
        for (int position = 1; position <= val.getmaxplayers(); position++) {
            if (player[position].equals(uplayer)) {
                time[position] = System.currentTimeMillis();
            }
        }
    }

    public void checkForTimeOut(String uplayer, Values val, UserData udata) {
        long delay;
        for (int position = 1; position <= val.getmaxplayers(); position++) {
            if (player[position].equals(uplayer)) {
                delay = (System.currentTimeMillis() - time[position]);
                System.out.println (uplayer + " has a delay of : " + delay/1000 + " sec.");
                if ( delay >= (val.getpingtimeoutdelay() * 1000) ) {
                    //System.out.println ("delay override. marked player " + uplayer + " to erase due ping timeout.");
                    this.closeSocket(uplayer, udata, val);
                }
            }
        }
    }

/*
    public boolean checkForPTORegistered(String uplayer, UserData udata, Values val) {
        boolean pto = false;
        for (int position = 1; position <= val.getmaxplayers(); position++) {
            //System.out.println (position + " has ping timeout valued " + pingtimeout[position]);
            if (player[position].equals(uplayer)) {
                pto = pingtimeout[position];
                //System.out.println ("AT " + position + " the pingtimeout got : " + pingtimeout[position] + " and the PTO is : " + pto);
            }
        }
        //System.out.println ("PTO is now : " + pto);
        if (pto) { System.out.println ("UserData:checkForPTORegistered ## local thread has now information to suicide."); }
        return pto;
    }
*/



    public void initUserData(UserData udate, String uplayer, Values val) {
        for (int position = 1; position <= val.getmaxplayers(); position++) {
            if (player[position].equals(uplayer)) {
                version[position] 	= "none";
                nick[position]		= "none";
                side[position]		= "none";
                colour[position]		= "none";
                time[position]          = 0;
                ready[position]         = false;
                connection[position]    = true;
                pingtimeout[position]   = false;
            }
        }
    }

    public boolean isConnected(UserData udata, int position) {
        //System.out.println (position + " is connected : " + connection[position]);
        return connection[position];
    }


    public String setUserInfo(UserData udata, String uplayer, String uversion, String unick, String uside, String ucolour, Values val) {
        String recvline = "";

        for (int position = 1; position <= val.getmaxplayers(); position++) {
            if (player[position].equals(uplayer)) {
                if (!ready[position]) {
                    version[position] = uversion;
                    nick[position] = unick;
                    side[position] = uside;
                    colour[position] = ucolour;
                }
                else
                {
                    recvline = this.printMessagetoClient(player[position], "DATA ALREADY LOCKED.");
                }
            }
        }
        return recvline;
    }

    public void printUserInfo(String uplayer, Values val) {
        String tmpstatus = "changing user profile";
        for (int position = 1; position <= val.getmaxplayers(); position++) {
            if (player[position].equals(uplayer)) {
                if ( (version[position] != "none") && (nick[position] != "none") && (side[position] != "none") && (colour[position] != "none") ) {
                    if (ready[position]) { tmpstatus = "awaiting game start"; }
                    System.out.println (player[position] + " ::: " + version[position] + " ::: " + nick[position] + " ::: " + side[position] + " ::: " + colour[position] + " ::: " + tmpstatus);
                }
            }
        }
    }

    public String printServerInfo(String uplayer, Values valuu) {
        String recvline;

        if (this.askforGameStart(valuu)) {
            System.out.println ("GAME CAN START NOW!");
            recvline = this.printMessagetoClient(uplayer, "GAME WILL BE STARTED BY SERVER NOW");
        }
        else {
            recvline = "AWATING OTHER PLAYERS TO JOIN";
        }
        return recvline;
    }

    // hier noch einstellen, dass er nur von 1 bis maxplayers zhlt
    public void cleanupUser(String uplayer, Values val) {
        for (int position = 1; position <= 7; position++) {
            if (player[position].equals(uplayer)) {
                version[position]       = "none";
                nick[position]		= "none";
                side[position]		= "none";
                colour[position]		= "none";
                ready[position]			= false;
                connection[position]    	= false;
                val.gamestate(0);
                System.out.println("cleaned up queue for player " + uplayer + ".");
            }
        }
    }

    public String printMessagetoClient(String uplayer, String message) {
        String recvline = null;
        recvline = "MESSAGE FROM MASTERSERVER to " + uplayer + " ::: " + message;
        return recvline;
    }

    public String printUserInfoToClient(String uplayer, Values val) {
        String recvline = null;
        String tmpstatus = "changing user profile";
        for (int position = 1; position <= val.getmaxplayers(); position++) {
            if (player[position].equals(uplayer)) {
                if ( (version[position] != "none") && (nick[position] != "none") && (side[position] != "none") && (colour[position] != "none") ) {
                    if (ready[position]) { tmpstatus = "awaiting game start"; }
                    recvline = player[position] + " ::: " + version[position] + " ::: " + nick[position] + " ::: " + side[position] + " ::: " + colour[position] + " ::: " + tmpstatus;
                }
            }
        }
        return recvline;
    }

    // hier noch einstellen, dass er nur von 1 bis maxplayers zhlt
    public boolean checkNick(String cid, String tempnick) {
        boolean retvalue = true;
        for (int position = 1; position <= 7; position++) {
            try {
                if ( (nick[position].compareTo("none") != 0) || (nick[position] != null) )
                {
                    if ( (nick[position].equals(tempnick)) )
                    {
                        retvalue = false;
                    }
                }
            } catch (NullPointerException e) {}
        }
	if (tempnick.equals("")) { retvalue = false; }
	if (tempnick.equals("none")) { retvalue = false; }
        return retvalue;
    }

    // hier noch einstellen, dass er nur von 1 bis maxplayers zhlt
    public boolean checkColour(String cid, String tempcolour) {
        boolean retvalue = true;

        //red, orange, yellow, green, blue and turquoise
        //System.out.println ("DEBUG!!!! -> tempcolour is : " + tempcolour + ".");
        if 	(
            (tempcolour.compareTo("red") != 0) &&
            (tempcolour.compareTo("orange") != 0) &&
            (tempcolour.compareTo("yellow") != 0) &&
            (tempcolour.compareTo("green") != 0) &&
            (tempcolour.compareTo("blue") != 0) &&
            (tempcolour.compareTo("turquoise") != 0)
        ) {
            retvalue = false;
        }
        else {

            for (int position = 1; position <= 7; position++) {
                try {
                    if (colour[position].compareTo("none") != 0 || (colour[position] != null) )
                    {
                        if ( (colour[position].equals(tempcolour)) )
                        {
                            retvalue = false;
                        }
                    }
                } catch (NullPointerException e) {}
            }
        }
        return retvalue;
    }

    public void putintoChatBuffer(String chatline) {
        ChatBuffer = chatline;
    }

    public void readfromChatBuffer() {
        if (ChatBuffer != null) { System.out.println(ChatBuffer); }
    }

    // hier noch einstellen, dass er nur von 1 bis maxplayers zhlt
    public synchronized String getPlayerID() {
        String tmpid;
        int position = 1;

        while ( (position <= 7) && (connection[position] == true) ) {
            position++;
        }
        tmpid = "player" + position;
        connection[position] = true;
        return tmpid;
    }

    public boolean checkUser(String user, Values val) {
        boolean tmp = false;
        for (int position = 1; position <= val.getmaxplayers(); position++) {
            if (player[position].equals(user)) {
                //System.out.println ("Userdata::checkUser : debug ### " + nick[position]);
                //System.out.println ("Userdata::checkUser : debug ### " + colour[position]);
                //System.out.println ("Userdata::checkUser : debug ### " + side[position]);
                //System.out.println ("Userdata::checkUser : debug ### " + version[position]);
		
		// if the arrays are everything except "none" its set as ready.
                if ( 	(nick[position].compareTo("none") != 0) &&
                        (version[position].compareTo("none") != 0) &&
                        (colour[position].compareTo("none") != 0) &&
                        (side[position].compareTo("none") != 0) )
                { tmp = true;	}
                else
                { tmp = false; }
            }
        }
        //System.out.println ("Userdata::checkUser : debug ### returning " + tmp + " to set this player ready");
        return tmp;
    }


    public boolean checkAllUsers(Values val) {
        boolean tmp = true;
        for (int position = 1; position <= val.getmaxplayers(); position++) {
            if (this.checkUser(player[position], val)) {
                //System.out.println ("Userdata::checkAllUsers : debug ### : " + player[position] + " is ready");
                tmp = true;
            }
            else {
                System.out.println ("Userdata::checkAllUsers : debug ### : " + player[position] + " is NOT ready");
                tmp = false;
            }
        }
        return tmp;
    }


    public boolean askforGameStart(Values val) {
        boolean retval = false;
        if ( (val.getmaxplayers() >= val.getplayernumber() ) && (this.checkAllUsers(val)) )
        {	retval = true; }
        return retval;
    }

    public String setClientAsReady(String user, Values val) {
        String rvline = "";
        for (int position = 1; position <= val.getmaxplayers(); position++) {
            if (player[position].equals(user)) {
                if (this.checkUser(user, val)) {
                    ready[position] = true;
                    System.out.println (player[position] + " announces to be ready to play");
                }
                else {
                    System.out.println (player[position] + "'s settings are refused by server");
                    ready[position] = false;
                }
            }
        }
        if ( val.getplayernumber() < val.getmaxplayers() ) {
            System.out.println ("waiting for " + (val.getmaxplayers() - val.getplayernumber()) + " more players");
        }
        else {
            val.gamestate(1);
            System.out.println ("All users are ready - so we can start the game.");
        }
        rvline = user + " is now marked as ready.";
        return rvline;
    }

}
